﻿Imports System.IO
Imports System.Reflection

Public Class frm_main
    Public Shared version As String = "v1.1"

    Dim _key_shift_ As Boolean = False

    Dim _file_bytes_() As Byte
    Dim prm_file_path As String = String.Empty
    Dim save_path As String = String.Empty

    Dim multi_line As Char = "|"
    Public Shared poly_count As Short = 0
    Public Shared vert_count As Short = 0
    Dim zoom As Double = 100.0

    Dim textures() As Bitmap = {Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing}
    Dim text_ass() As String = {"file: a", "file: b", "file: c", "file: d", "file: e", "file: f", "file: g", "file: h", "file: i", "file: j"}
    Public Shared new_textures() As Bitmap = {Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing, Nothing}

    Public Shared polygon(,) As String
    '0: type
    '1: texture
    '2: vertex #
    '3: ARGB
    '4: U
    '5: V
    '6: New texture
    '7: New U
    '8: New V

    Public Shared vertex(,) As String
    '0: position X
    '1: position Y
    '2: position Z
    '3: normal X
    '4: normal Y
    '5: normal Z

    Dim edit_rl As Integer = 0
    Dim edit_ud As Integer = 0

    Private Sub frm_main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text = "Re-Volt Instance Tool " & version
        Me.cmb_instance_border_color.Text = "Red"

        Dim aProp As System.Reflection.PropertyInfo = GetType(Panel).GetProperty("DoubleBuffered", System.Reflection.BindingFlags.NonPublic Or System.Reflection.BindingFlags.Instance)
        aProp.SetValue(Me.pnlpic_texture_instance, True, Nothing)
        aProp.SetValue(Me.pnlpic_texture_new, True, Nothing)

        Me.cmb_zoom.Text = "100%" : zoom = 100.0

        Me.ResetDataInfo()
    End Sub
    Private Sub frm_main_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        Select Case e.KeyCode
            Case Keys.ShiftKey
                _key_shift_ = True
        End Select
    End Sub
    Private Sub frm_main_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp
        Select Case e.KeyCode
            Case Keys.ShiftKey
                _key_shift_ = False
        End Select
    End Sub
    Private Sub btt_about_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_about.Click
        My.Forms.frm_about.ShowDialog(Me)
    End Sub

    Private Sub btt_open_instance_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_open_instance.Click
        If Me.OFD_PRM.ShowDialog = Windows.Forms.DialogResult.OK Then
            prm_file_path = Me.OFD_PRM.FileName
            Me.Text = "Re-Volt Instance Tool " & version & " [" & prm_file_path & "]"

            Me.LoadDataInfo()

            Me.pnlpic_texture_instance.Refresh()
        End If
    End Sub
    Private Sub btt_show_data_info_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_show_data_info.Click
        If poly_count > 0 Then
            My.Forms.frm_data_info.ShowDialog(Me)
        End If
    End Sub

    Private Sub cmb_instance_texture_list_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_instance_texture_list.SelectedIndexChanged
        Dim temp_bmp As Bitmap = Nothing

        temp_bmp = textures(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text))
        If temp_bmp IsNot Nothing Then
            Me.pnlpic_texture_instance.BackgroundImage = Me.ResizeImage(temp_bmp)
            Me.pnlpic_texture_instance.Width = Me.pnlpic_texture_instance.BackgroundImage.Width
            Me.pnlpic_texture_instance.Height = Me.pnlpic_texture_instance.BackgroundImage.Height
            Me.pnlpic_texture_instance.Location = New Point(3, 3)
        Else
            Me.pnlpic_texture_instance.BackgroundImage = Nothing
        End If

        temp_bmp = new_textures(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text))
        If temp_bmp IsNot Nothing Then
            Me.pnlpic_texture_new.BackgroundImage = Me.ResizeImage(temp_bmp)
            Me.pnlpic_texture_new.Width = Me.pnlpic_texture_new.BackgroundImage.Width
            Me.pnlpic_texture_new.Height = Me.pnlpic_texture_new.BackgroundImage.Height
            Me.pnlpic_texture_new.Location = New Point(3, 3)
        Else
            Me.pnlpic_texture_new.BackgroundImage = Nothing
        End If

        Me.cmb_new_texture_list.Text = text_ass(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text))

        Me.DisableEdit()
    End Sub
    Private Sub cmb_new_texture_list_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_new_texture_list.SelectedIndexChanged
        If Me.cmb_instance_texture_list.Text <> String.Empty Then
            text_ass(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text)) = Me.cmb_new_texture_list.Text

            For i As Integer = 0 To poly_count - 1
                If polygon(1, i) = Me.cmb_instance_texture_list.Text Then
                    polygon(6, i) = Me.cmb_new_texture_list.Text
                End If

                My.Application.DoEvents()
            Next
        End If
    End Sub
    Private Sub cmb_zoom_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_zoom.SelectedIndexChanged
        zoom = CDbl(Me.cmb_zoom.Text.Replace("%", String.Empty))

        Dim temp_bmp As Bitmap = Nothing

        If Me.cmb_instance_texture_list.Text <> String.Empty Then
            temp_bmp = textures(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text))
            If temp_bmp IsNot Nothing Then
                Me.pnlpic_texture_instance.BackgroundImage = Me.ResizeImage(temp_bmp)
                Me.pnlpic_texture_instance.Width = Me.pnlpic_texture_instance.BackgroundImage.Width
                Me.pnlpic_texture_instance.Height = Me.pnlpic_texture_instance.BackgroundImage.Height
                Me.pnlpic_texture_instance.Location = New Point(3, 3)
            Else
                Me.pnlpic_texture_instance.BackgroundImage = Nothing
            End If
        
            temp_bmp = new_textures(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text))
            If temp_bmp IsNot Nothing Then
                Me.pnlpic_texture_new.BackgroundImage = Me.ResizeImage(temp_bmp)
                Me.pnlpic_texture_new.Width = Me.pnlpic_texture_new.BackgroundImage.Width
                Me.pnlpic_texture_new.Height = Me.pnlpic_texture_new.BackgroundImage.Height
                Me.pnlpic_texture_new.Location = New Point(3, 3)
            Else
                Me.pnlpic_texture_new.BackgroundImage = Nothing
            End If
        End If
    End Sub

    Private Sub btt_set_texture_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_set_texture.Click
        If Me.cmb_instance_texture_list.Text <> String.Empty _
            AndAlso Me.OFD_BMP.ShowDialog = Windows.Forms.DialogResult.OK Then

            Dim temp_bmp As Bitmap = Bitmap.FromFile(Me.OFD_BMP.FileName)

            textures(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text)) = temp_bmp

            Me.pnlpic_texture_instance.BackgroundImage = Me.ResizeImage(temp_bmp)
            Me.pnlpic_texture_instance.Width = Me.pnlpic_texture_instance.BackgroundImage.Width
            Me.pnlpic_texture_instance.Height = Me.pnlpic_texture_instance.BackgroundImage.Height
            Me.pnlpic_texture_instance.Location = New Point(3, 3)

            Me.RefreshNewUVCoords()

            Me.pnlpic_texture_instance.Refresh()
            Me.pnlpic_texture_new.Refresh()
        End If
    End Sub
    Private Sub pnlpic_texture_instance_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlpic_texture_instance.Paint
        If Me.cmb_instance_texture_list.Text <> String.Empty Then
            If Not Me.pnlpic_texture_instance.BackgroundImage Is Nothing Then
                Dim myPen As New Pen(Color.FromName(Me.cmb_instance_border_color.Text.Replace("Green", "GreenYellow")), 1)
                Dim coord_uv(,) As Single
                Dim ppoints() As PointF
                Dim count As Integer = 0

                For i As Integer = 0 To poly_count - 1
                    If polygon(1, i) = Me.cmb_instance_texture_list.Text Then
                        coord_uv = LoadCoordUV(polygon(0, i), polygon(4, i), polygon(5, i))

                        If polygon(0, i).StartsWith("Q") Then 'square
                            ReDim ppoints(3)
                            ppoints(0).X = CSng(Me.pnlpic_texture_instance.Width) * coord_uv(0, 0)
                            ppoints(0).Y = CSng(Me.pnlpic_texture_instance.Height) * coord_uv(1, 0)
                            ppoints(1).X = CSng(Me.pnlpic_texture_instance.Width) * coord_uv(0, 1)
                            ppoints(1).Y = CSng(Me.pnlpic_texture_instance.Height) * coord_uv(1, 1)
                            ppoints(2).X = CSng(Me.pnlpic_texture_instance.Width) * coord_uv(0, 2)
                            ppoints(2).Y = CSng(Me.pnlpic_texture_instance.Height) * coord_uv(1, 2)
                            ppoints(3).X = CSng(Me.pnlpic_texture_instance.Width) * coord_uv(0, 3)
                            ppoints(3).Y = CSng(Me.pnlpic_texture_instance.Height) * coord_uv(1, 3)
                        Else 'triangle
                            ReDim ppoints(2)
                            ppoints(0).X = CSng(Me.pnlpic_texture_instance.Width) * coord_uv(0, 0)
                            ppoints(0).Y = CSng(Me.pnlpic_texture_instance.Height) * coord_uv(1, 0)
                            ppoints(1).X = CSng(Me.pnlpic_texture_instance.Width) * coord_uv(0, 1)
                            ppoints(1).Y = CSng(Me.pnlpic_texture_instance.Height) * coord_uv(1, 1)
                            ppoints(2).X = CSng(Me.pnlpic_texture_instance.Width) * coord_uv(0, 2)
                            ppoints(2).Y = CSng(Me.pnlpic_texture_instance.Height) * coord_uv(1, 2)
                        End If

                        If Me.opt_fill_yes.Checked Then
                            e.Graphics.FillPolygon(Brushes.Tan, ppoints)
                        ElseIf Me.opt_fill_20.Checked Then
                            e.Graphics.FillPolygon(New SolidBrush(Color.FromArgb(50, 210, 180, 140)), ppoints)
                        End If
                        e.Graphics.DrawPolygon(myPen, ppoints)

                        count += 1
                    End If

                    'My.Application.DoEvents()
                Next
            End If
        End If
    End Sub

    Private Sub btt_set_texture_new_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_set_texture_new.Click
        If Me.cmb_instance_texture_list.Text <> String.Empty _
            AndAlso Me.OFD_BMP.ShowDialog = Windows.Forms.DialogResult.OK Then

            Dim temp_bmp As Bitmap = Bitmap.FromFile(Me.OFD_BMP.FileName)

            new_textures(Me.GetCmbTextureFileID(Me.cmb_instance_texture_list.Text)) = temp_bmp

            Me.pnlpic_texture_new.BackgroundImage = Me.ResizeImage(temp_bmp)
            Me.pnlpic_texture_new.Width = Me.pnlpic_texture_new.BackgroundImage.Width
            Me.pnlpic_texture_new.Height = Me.pnlpic_texture_new.BackgroundImage.Height
            Me.pnlpic_texture_new.Location = New Point(3, 3)

            Me.RefreshNewUVCoords()

            Me.pnlpic_texture_instance.Refresh()
            Me.pnlpic_texture_new.Refresh()
        End If
    End Sub
    Private Sub pnlpic_texture_new_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles pnlpic_texture_new.Paint
        If Me.cmb_instance_texture_list.Text <> String.Empty Then
            If Not Me.pnlpic_texture_new.BackgroundImage Is Nothing Then
                Dim myPen As New Pen(Color.FromName(Me.cmb_instance_border_color.Text.Replace("Green", "GreenYellow")), 1)
                Dim coord_uv(,) As Single
                Dim ppoints() As PointF

                Dim _factor_ As Single = CSng(1.0) / CSng(Me.pnlpic_texture_new.Width)

                For i As Integer = 0 To poly_count - 1
                    If polygon(1, i) = Me.cmb_instance_texture_list.Text Then
                        If polygon(7, i) = String.Empty Then
                            coord_uv = LoadCoordUV(polygon(0, i), polygon(4, i), polygon(5, i))
                        Else
                            coord_uv = LoadCoordUV(polygon(0, i), polygon(7, i), polygon(8, i))
                        End If

                        If polygon(0, i).StartsWith("Q") Then 'square
                            ReDim ppoints(3)
                            ppoints(0).X = CSng(Me.pnlpic_texture_new.Width) * (coord_uv(0, 0) + (_factor_ * edit_rl))
                            ppoints(0).Y = CSng(Me.pnlpic_texture_new.Height) * (coord_uv(1, 0) + (_factor_ * edit_ud))
                            ppoints(1).X = CSng(Me.pnlpic_texture_new.Width) * (coord_uv(0, 1) + (_factor_ * edit_rl))
                            ppoints(1).Y = CSng(Me.pnlpic_texture_new.Height) * (coord_uv(1, 1) + (_factor_ * edit_ud))
                            ppoints(2).X = CSng(Me.pnlpic_texture_new.Width) * (coord_uv(0, 2) + (_factor_ * edit_rl))
                            ppoints(2).Y = CSng(Me.pnlpic_texture_new.Height) * (coord_uv(1, 2) + (_factor_ * edit_ud))
                            ppoints(3).X = CSng(Me.pnlpic_texture_new.Width) * (coord_uv(0, 3) + (_factor_ * edit_rl))
                            ppoints(3).Y = CSng(Me.pnlpic_texture_new.Height) * (coord_uv(1, 3) + (_factor_ * edit_ud))
                        Else 'triangle
                            ReDim ppoints(2)
                            ppoints(0).X = CSng(Me.pnlpic_texture_new.Width) * (coord_uv(0, 0) + (_factor_ * edit_rl))
                            ppoints(0).Y = CSng(Me.pnlpic_texture_new.Height) * (coord_uv(1, 0) + (_factor_ * edit_ud))
                            ppoints(1).X = CSng(Me.pnlpic_texture_new.Width) * (coord_uv(0, 1) + (_factor_ * edit_rl))
                            ppoints(1).Y = CSng(Me.pnlpic_texture_new.Height) * (coord_uv(1, 1) + (_factor_ * edit_ud))
                            ppoints(2).X = CSng(Me.pnlpic_texture_new.Width) * (coord_uv(0, 2) + (_factor_ * edit_rl))
                            ppoints(2).Y = CSng(Me.pnlpic_texture_new.Height) * (coord_uv(1, 2) + (_factor_ * edit_ud))
                        End If

                        If Me.opt_fill_yes.Checked Then
                            e.Graphics.FillPolygon(Brushes.Tan, ppoints)
                        ElseIf Me.opt_fill_20.Checked Then
                            e.Graphics.FillPolygon(New SolidBrush(Color.FromArgb(50, 210, 180, 140)), ppoints)
                        End If
                        e.Graphics.DrawPolygon(myPen, ppoints)
                    End If

                    'My.Application.DoEvents()
                Next
            End If
        End If
    End Sub

    Dim from_btt_save As Boolean = False

    Private Sub btt_save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_save.Click
        If Me.cmb_instance_texture_list.Text <> String.Empty Then
            If save_path = String.Empty Then
                from_btt_save = True
                btt_save_as_Click(Nothing, Nothing)
            Else
                File.WriteAllBytes(save_path, Me.GetDataBytes())

                Me.btt_save.Image = My.Resources.ok
                Me.tmr.Enabled = True
            End If
        End If
    End Sub
    Private Sub btt_save_as_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_save_as.Click
        If Me.cmb_instance_texture_list.Text <> String.Empty Then
            If Me.SFD_PRM.ShowDialog = Windows.Forms.DialogResult.OK Then
                save_path = Me.SFD_PRM.FileName

                File.WriteAllBytes(save_path, Me.GetDataBytes())

                Me.Text = "Re-Volt Instance Tool " & version & " [" & save_path & "]"

                If from_btt_save Then
                    from_btt_save = False
                    Me.btt_save.Image = My.Resources.ok
                Else
                    Me.btt_save_as.Image = My.Resources.ok
                End If
                Me.tmr.Enabled = True
            End If
        End If
    End Sub
    Private Function GetDataBytes() As Byte()
        Dim databytes(3 + (poly_count * 60) + (vert_count * 24)) As Byte
        'Dim temp As String = String.Empty
        Dim t1(), t2() As Byte

        'poly count
        databytes(0) = _file_bytes_(0)
        databytes(1) = _file_bytes_(1)
        'vertex count
        databytes(2) = _file_bytes_(2)
        databytes(3) = _file_bytes_(3)

        For i As Integer = 0 To poly_count - 1
            'type
            databytes(4 + (i * 60) + 0) = _file_bytes_(4 + (i * 60) + 0)
            databytes(4 + (i * 60) + 1) = _file_bytes_(4 + (i * 60) + 1)
            'texture
            If polygon(6, i) = String.Empty Then
                databytes(4 + (i * 60) + 2) = _file_bytes_(4 + (i * 60) + 2)
                databytes(4 + (i * 60) + 3) = _file_bytes_(4 + (i * 60) + 3)
            Else
                t1 = BitConverter.GetBytes(Me.GetCmbTextureFileID(polygon(6, i)))

                If Not BitConverter.IsLittleEndian Then
                    Array.Reverse(t1)
                End If

                databytes(4 + (i * 60) + 2) = t1(0)
                databytes(4 + (i * 60) + 3) = t1(1)
            End If
            'vertices
            For k As Integer = 4 To 11
                databytes(4 + (i * 60) + k) = _file_bytes_(4 + (i * 60) + k)
            Next
            'color
            For k As Integer = 12 To 27
                databytes(4 + (i * 60) + k) = _file_bytes_(4 + (i * 60) + k)
            Next
            'UV
            If polygon(7, i) = String.Empty Then
                For k As Integer = 28 To 59
                    databytes(4 + (i * 60) + k) = _file_bytes_(4 + (i * 60) + k)
                Next
            Else
                For k As Integer = 0 To 3
                    t1 = BitConverter.GetBytes(CSng(polygon(7, i).Split(multi_line)(k)))
                    t2 = BitConverter.GetBytes(CSng(polygon(8, i).Split(multi_line)(k)))

                    If Not BitConverter.IsLittleEndian Then
                        Array.Reverse(t1)
                        Array.Reverse(t2)
                    End If

                    For kk As Integer = 0 To 3
                        databytes(4 + (i * 60) + 28 + (k * 8) + kk) = t1(kk)
                    Next
                    For kk As Integer = 0 To 3
                        databytes(4 + (i * 60) + 32 + (k * 8) + kk) = t2(kk)
                    Next
                Next
            End If

            My.Application.DoEvents()
        Next

        For i As Integer = 0 To (vert_count * 24) - 1
            databytes(4 + (poly_count * 60) + i) = _file_bytes_(4 + (poly_count * 60) + i)

            My.Application.DoEvents()
        Next

        Return databytes
    End Function

    Private Sub pnl_texture_new_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles pnl_texture_new.SizeChanged
        Me.pnlpic_texture_instance.Location = New Point(3, 3)
        Me.pnlpic_texture_instance.Refresh()
        Me.pnlpic_texture_new.Location = New Point(3, 3)
        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub cmb_instance_border_color_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_instance_border_color.SelectedIndexChanged
        Me.pnlpic_texture_instance.Refresh()
        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub opt_fill_yes_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt_fill_yes.CheckedChanged
        Me.pnlpic_texture_instance.Refresh()
        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub opt_fill_20_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt_fill_20.CheckedChanged
        Me.pnlpic_texture_instance.Refresh()
        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub opt_fill_no_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles opt_fill_no.CheckedChanged
        Me.pnlpic_texture_instance.Refresh()
        Me.pnlpic_texture_new.Refresh()
    End Sub

    Private Sub tmr_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmr.Tick
        Me.tmr.Enabled = False
        Me.btt_save_edit.Image = My.Resources.save
        Me.btt_save.Image = My.Resources.save
        Me.btt_save_as.Image = My.Resources.save_as
    End Sub

    '--- EDIT ---

    Private Sub btt_enable_edit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_enable_edit.Click
        If Me.pnlpic_texture_new.BackgroundImage IsNot Nothing Then
            Me.EnableEdit()
            Me.pnlpic_texture_new.Focus()
        End If
    End Sub

    Private Sub btt_left_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_left.Click
        If Me.chk_zoom_anchor.Checked Then
            If _key_shift_ Then
                edit_rl -= CInt(16.0 * zoom / 100.0)
            Else
                edit_rl -= CInt(1.0 * zoom / 100.0)
            End If
        Else
            If _key_shift_ Then
                edit_rl -= 16
            Else
                edit_rl -= 1
            End If
        End If

        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub btt_right_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_right.Click
        If Me.chk_zoom_anchor.Checked Then
            If _key_shift_ Then
                edit_rl += CInt(16.0 * zoom / 100.0)
            Else
                edit_rl += CInt(1.0 * zoom / 100.0)
            End If
        Else
            If _key_shift_ Then
                edit_rl += 16
            Else
                edit_rl += 1
            End If
        End If

        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub btt_up_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_up.Click
        If Me.chk_zoom_anchor.Checked Then
            If _key_shift_ Then
                edit_ud -= CInt(16.0 * zoom / 100.0)
            Else
                edit_ud -= CInt(1.0 * zoom / 100.0)
            End If
        Else
            If _key_shift_ Then
                edit_ud -= 16
            Else
                edit_ud -= 1
            End If
        End If

        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub btt_down_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_down.Click
        If Me.chk_zoom_anchor.Checked Then
            If _key_shift_ Then
                edit_ud += CInt(16.0 * zoom / 100.0)
            Else
                edit_ud += CInt(1.0 * zoom / 100.0)
            End If
        Else
            If _key_shift_ Then
                edit_ud += 16
            Else
                edit_ud += 1
            End If
        End If

        Me.pnlpic_texture_new.Refresh()
    End Sub

    Private Sub btt_close_edit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_close_edit.Click
        Me.DisableEdit()

        Me.pnlpic_texture_new.Refresh()
    End Sub
    Private Sub btt_save_edit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btt_save_edit.Click
        Dim _factor_ As Single = CSng(1.0) / CSng(Me.pnlpic_texture_new.Width)
        Dim coord_uv(,) As Single

        If edit_rl <> 0 OrElse edit_ud <> 0 Then
            If edit_rl <> 0 Then
                For i As Integer = 0 To poly_count - 1
                    If polygon(1, i) = Me.cmb_instance_texture_list.Text Then
                        If polygon(7, i) = String.Empty Then
                            coord_uv = LoadCoordUV(polygon(0, i), polygon(4, i), polygon(5, i))
                        Else
                            coord_uv = LoadCoordUV(polygon(0, i), polygon(7, i), polygon(8, i))
                        End If

                        coord_uv(0, 0) += (_factor_ * edit_rl)
                        coord_uv(0, 1) += (_factor_ * edit_rl)
                        coord_uv(0, 2) += (_factor_ * edit_rl)
                        If polygon(0, i).StartsWith("Q") Then 'square
                            coord_uv(0, 3) += (_factor_ * edit_rl)
                        End If

                        If polygon(0, i).StartsWith("Q") Then 'square
                            polygon(7, i) = coord_uv(0, 0).ToString & multi_line & coord_uv(0, 1).ToString & multi_line & coord_uv(0, 2).ToString & multi_line & coord_uv(0, 3).ToString
                        Else 'triangle
                            polygon(7, i) = coord_uv(0, 0).ToString & multi_line & coord_uv(0, 1).ToString & multi_line & coord_uv(0, 2).ToString & multi_line & "0"
                        End If
                    End If
                Next

                edit_rl = 0

                Me.btt_save_edit.Image = My.Resources.ok
            End If

            If edit_ud <> 0 Then
                For i As Integer = 0 To poly_count - 1
                    If polygon(1, i) = Me.cmb_instance_texture_list.Text Then
                        If polygon(8, i) = String.Empty Then
                            coord_uv = LoadCoordUV(polygon(0, i), polygon(4, i), polygon(5, i))
                        Else
                            coord_uv = LoadCoordUV(polygon(0, i), polygon(7, i), polygon(8, i))
                        End If

                        coord_uv(1, 0) += (_factor_ * edit_ud)
                        coord_uv(1, 1) += (_factor_ * edit_ud)
                        coord_uv(1, 2) += (_factor_ * edit_ud)
                        If polygon(0, i).StartsWith("Q") Then 'square
                            coord_uv(1, 3) += (_factor_ * edit_ud)
                        End If

                        If polygon(0, i).StartsWith("Q") Then 'square
                            polygon(8, i) = coord_uv(1, 0).ToString & multi_line & coord_uv(1, 1).ToString & multi_line & coord_uv(1, 2).ToString & multi_line & coord_uv(1, 3).ToString
                        Else 'triangle
                            polygon(8, i) = coord_uv(1, 0).ToString & multi_line & coord_uv(1, 1).ToString & multi_line & coord_uv(1, 2).ToString & multi_line & "0"
                        End If
                    End If
                Next

                edit_ud = 0

                Me.btt_save_edit.Image = My.Resources.ok
            End If

            Me.tmr.Enabled = True
        End If
    End Sub

    '--- SUBs ---

    Private Sub LoadDataInfo()
        Me.ResetDataInfo()

        If Not File.Exists(prm_file_path) Then
            Exit Sub
        End If

        _file_bytes_ = File.ReadAllBytes(prm_file_path)

        poly_count = Me.RVShortToShort(_file_bytes_(0), _file_bytes_(1))
        vert_count = Me.RVShortToShort(_file_bytes_(2), _file_bytes_(3))

        If poly_count > 0 AndAlso vert_count > 0 Then
            Dim type As Int16 = 0
            Dim texture_link As Int16 = 0

            ReDim polygon(8, poly_count - 1)

            For i As Short = 0 To CShort(poly_count - 1)
                texture_link = Me.RVShortToShort(_file_bytes_((i * 60) + 6), _file_bytes_((i * 60) + 7))
                type = Me.RVShortToShort(_file_bytes_((i * 60) + 4), _file_bytes_((i * 60) + 5))

                '--- 0
                polygon(0, i) = String.Empty
                If Convert.ToString(type, 2).PadLeft(16, "0").Substring(15, 1) = "1" Then
                    polygon(0, i) &= "Q "
                Else
                    polygon(0, i) &= "T "
                End If
                If Convert.ToString(type, 2).PadLeft(16, "0").Substring(14, 1) = "1" Then
                    polygon(0, i) &= "DS "
                End If
                If Convert.ToString(type, 2).PadLeft(16, "0").Substring(13, 1) = "1" Then
                    polygon(0, i) &= "Tr "
                Else
                    polygon(0, i) &= "Mr "
                End If
                If Convert.ToString(type, 2).PadLeft(16, "0").Substring(7, 1) = "1" Then
                    polygon(0, i) &= "Alp "
                Else
                    polygon(0, i) &= "Add "
                End If
                If Convert.ToString(type, 2).PadLeft(16, "0").Substring(5, 1) = "1" Then
                    polygon(0, i) &= "dEnvM "
                End If
                polygon(0, i) = polygon(0, i).Trim
                '--- 1
                If texture_link = -1 Then
                    polygon(1, i) = "Color filled"
                ElseIf texture_link = 0 Then
                    polygon(1, i) = "file: a"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: a") Then
                        Me.cmb_instance_texture_list.Items.Add("file: a")
                    End If
                ElseIf texture_link = 1 Then
                    polygon(1, i) = "file: b"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: b") Then
                        Me.cmb_instance_texture_list.Items.Add("file: b")
                    End If
                ElseIf texture_link = 2 Then
                    polygon(1, i) = "file: c"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: c") Then
                        Me.cmb_instance_texture_list.Items.Add("file: c")
                    End If
                ElseIf texture_link = 3 Then
                    polygon(1, i) = "file: d"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: d") Then
                        Me.cmb_instance_texture_list.Items.Add("file: d")
                    End If
                ElseIf texture_link = 4 Then
                    polygon(1, i) = "file: e"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: e") Then
                        Me.cmb_instance_texture_list.Items.Add("file: e")
                    End If
                ElseIf texture_link = 5 Then
                    polygon(1, i) = "file: f"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: f") Then
                        Me.cmb_instance_texture_list.Items.Add("file: f")
                    End If
                ElseIf texture_link = 6 Then
                    polygon(1, i) = "file: g"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: g") Then
                        Me.cmb_instance_texture_list.Items.Add("file: g")
                    End If
                ElseIf texture_link = 7 Then
                    polygon(1, i) = "file: h"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: h") Then
                        Me.cmb_instance_texture_list.Items.Add("file: h")
                    End If
                ElseIf texture_link = 8 Then
                    polygon(1, i) = "file: i"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: i") Then
                        Me.cmb_instance_texture_list.Items.Add("file: i")
                    End If
                ElseIf texture_link = 9 Then
                    polygon(1, i) = "file: j"

                    If Not Me.cmb_instance_texture_list.Items.Contains("file: j") Then
                        Me.cmb_instance_texture_list.Items.Add("file: j")
                    End If
                End If
                '--- 2
                polygon(2, i) = Me.RVShortToShort(_file_bytes_((i * 60) + 8), _file_bytes_((i * 60) + 9)).ToString & multi_line & Me.RVShortToShort(_file_bytes_((i * 60) + 10), _file_bytes_((i * 60) + 11)).ToString & multi_line & Me.RVShortToShort(_file_bytes_((i * 60) + 12), _file_bytes_((i * 60) + 13)).ToString & multi_line & Me.RVShortToShort(_file_bytes_((i * 60) + 14), _file_bytes_((i * 60) + 15)).ToString
                polygon(3, i) = Me.RVColorToString(_file_bytes_((i * 60) + 16), _file_bytes_((i * 60) + 17), _file_bytes_((i * 60) + 18), _file_bytes_((i * 60) + 19)) & multi_line & Me.RVColorToString(_file_bytes_((i * 60) + 20), _file_bytes_((i * 60) + 21), _file_bytes_((i * 60) + 22), _file_bytes_((i * 60) + 23)) & multi_line & Me.RVColorToString(_file_bytes_((i * 60) + 24), _file_bytes_((i * 60) + 25), _file_bytes_((i * 60) + 26), _file_bytes_((i * 60) + 27)) & multi_line & Me.RVColorToString(_file_bytes_((i * 60) + 28), _file_bytes_((i * 60) + 29), _file_bytes_((i * 60) + 30), _file_bytes_((i * 60) + 31))
                polygon(4, i) = Me.RVFloatToSingle(_file_bytes_((i * 60) + 32), _file_bytes_((i * 60) + 33), _file_bytes_((i * 60) + 34), _file_bytes_((i * 60) + 35)).ToString & multi_line & Me.RVFloatToSingle(_file_bytes_((i * 60) + 40), _file_bytes_((i * 60) + 41), _file_bytes_((i * 60) + 42), _file_bytes_((i * 60) + 43)).ToString & multi_line & Me.RVFloatToSingle(_file_bytes_((i * 60) + 48), _file_bytes_((i * 60) + 49), _file_bytes_((i * 60) + 50), _file_bytes_((i * 60) + 51)).ToString & multi_line & Me.RVFloatToSingle(_file_bytes_((i * 60) + 56), _file_bytes_((i * 60) + 57), _file_bytes_((i * 60) + 58), _file_bytes_((i * 60) + 59)).ToString
                polygon(5, i) = Me.RVFloatToSingle(_file_bytes_((i * 60) + 36), _file_bytes_((i * 60) + 37), _file_bytes_((i * 60) + 38), _file_bytes_((i * 60) + 39)).ToString & multi_line & Me.RVFloatToSingle(_file_bytes_((i * 60) + 44), _file_bytes_((i * 60) + 45), _file_bytes_((i * 60) + 46), _file_bytes_((i * 60) + 47)).ToString & multi_line & Me.RVFloatToSingle(_file_bytes_((i * 60) + 52), _file_bytes_((i * 60) + 53), _file_bytes_((i * 60) + 54), _file_bytes_((i * 60) + 55)).ToString & multi_line & Me.RVFloatToSingle(_file_bytes_((i * 60) + 60), _file_bytes_((i * 60) + 61), _file_bytes_((i * 60) + 62), _file_bytes_((i * 60) + 63)).ToString

                polygon(6, i) = String.Empty
                polygon(7, i) = String.Empty
                polygon(8, i) = String.Empty

                My.Application.DoEvents()
            Next

            ReDim vertex(5, vert_count - 1)

            For i As Short = 0 To CShort(vert_count - 1)
                vertex(0, i) = Me.RVFloatToSingle(_file_bytes_((poly_count * 60) + (i * 24) + 4), _file_bytes_((poly_count * 60) + (i * 24) + 5), _file_bytes_((poly_count * 60) + (i * 24) + 6), _file_bytes_((poly_count * 60) + (i * 24) + 7)).ToString
                vertex(1, i) = Me.RVFloatToSingle(_file_bytes_((poly_count * 60) + (i * 24) + 8), _file_bytes_((poly_count * 60) + (i * 24) + 9), _file_bytes_((poly_count * 60) + (i * 24) + 10), _file_bytes_((poly_count * 60) + (i * 24) + 11)).ToString
                vertex(2, i) = Me.RVFloatToSingle(_file_bytes_((poly_count * 60) + (i * 24) + 12), _file_bytes_((poly_count * 60) + (i * 24) + 13), _file_bytes_((poly_count * 60) + (i * 24) + 14), _file_bytes_((poly_count * 60) + (i * 24) + 15)).ToString
                vertex(3, i) = Me.RVFloatToSingle(_file_bytes_((poly_count * 60) + (i * 24) + 16), _file_bytes_((poly_count * 60) + (i * 24) + 17), _file_bytes_((poly_count * 60) + (i * 24) + 18), _file_bytes_((poly_count * 60) + (i * 24) + 19)).ToString
                vertex(4, i) = Me.RVFloatToSingle(_file_bytes_((poly_count * 60) + (i * 24) + 20), _file_bytes_((poly_count * 60) + (i * 24) + 21), _file_bytes_((poly_count * 60) + (i * 24) + 22), _file_bytes_((poly_count * 60) + (i * 24) + 23)).ToString
                vertex(5, i) = Me.RVFloatToSingle(_file_bytes_((poly_count * 60) + (i * 24) + 24), _file_bytes_((poly_count * 60) + (i * 24) + 25), _file_bytes_((poly_count * 60) + (i * 24) + 26), _file_bytes_((poly_count * 60) + (i * 24) + 27)).ToString

                My.Application.DoEvents()
            Next

            If Me.cmb_instance_texture_list.Items.Count > 0 Then
                Me.cmb_new_texture_list.Text = Me.cmb_instance_texture_list.Items(0).ToString
                Me.cmb_instance_texture_list.Text = Me.cmb_instance_texture_list.Items(0).ToString
            End If
        End If
    End Sub
    Private Sub ResetDataInfo()
        Me.DisableEdit()

        For i As Byte = 0 To 9
            textures(i) = Nothing
        Next
        text_ass(0) = "file: a"
        text_ass(1) = "file: b"
        text_ass(2) = "file: c"
        text_ass(3) = "file: d"
        text_ass(4) = "file: e"
        text_ass(5) = "file: f"
        text_ass(6) = "file: g"
        text_ass(7) = "file: h"
        text_ass(8) = "file: i"
        text_ass(9) = "file: j"
        For i As Byte = 0 To 9
            new_textures(i) = Nothing
        Next

        poly_count = 0
        vert_count = 0

        Me.cmb_instance_texture_list.Items.Clear()

        save_path = String.Empty
    End Sub

    Private Sub EnableEdit()
        Me.btt_enable_edit.Enabled = False
        Me.btt_left.Enabled = True
        Me.btt_up.Enabled = True
        Me.btt_down.Enabled = True
        Me.btt_right.Enabled = True
        Me.btt_close_edit.Enabled = True
        Me.btt_save_edit.Enabled = True

        Me.chk_zoom_anchor.Enabled = True
    End Sub
    Private Sub DisableEdit()
        Me.btt_enable_edit.Enabled = True
        Me.btt_left.Enabled = False
        Me.btt_up.Enabled = False
        Me.btt_down.Enabled = False
        Me.btt_right.Enabled = False
        Me.btt_close_edit.Enabled = False
        Me.btt_save_edit.Enabled = False

        Me.chk_zoom_anchor.Enabled = False

        edit_rl = 0
        edit_ud = 0
    End Sub

    Private Function RVShortToShort(ByVal byte1 As Byte, _
                                    ByVal byte2 As Byte) As Short
        Try
            Dim bb(1) As Byte

            If BitConverter.IsLittleEndian Then
                bb(0) = byte1
                bb(1) = byte2
            Else
                bb(0) = byte2
                bb(1) = byte1
            End If

            Return BitConverter.ToInt16(bb, 0)
        Catch ex As Exception
            Return 0
        End Try
    End Function
    Private Function RVUShortToUShort(ByVal byte1 As Byte, _
                                      ByVal byte2 As Byte) As UShort
        Try
            Dim bb(1) As Byte

            If BitConverter.IsLittleEndian Then
                bb(0) = byte1
                bb(1) = byte2
            Else
                bb(0) = byte2
                bb(1) = byte1
            End If

            Return BitConverter.ToUInt16(bb, 0)
        Catch ex As Exception
            Return 0
        End Try
    End Function
    Private Function RVLongToInteger(ByVal byte1 As Byte, _
                                     ByVal byte2 As Byte, _
                                     ByVal byte3 As Byte, _
                                     ByVal byte4 As Byte) As Integer
        Try
            Dim bb(3) As Byte

            If BitConverter.IsLittleEndian Then
                bb(0) = byte1
                bb(1) = byte2
                bb(2) = byte3
                bb(3) = byte4
            Else
                bb(0) = byte4
                bb(1) = byte3
                bb(2) = byte2
                bb(3) = byte1
            End If

            Return BitConverter.ToInt32(bb, 0)
        Catch ex As Exception
            Return 0
        End Try
    End Function
    Private Function RVULongToUInteger(ByVal byte1 As Byte, _
                                       ByVal byte2 As Byte, _
                                       ByVal byte3 As Byte, _
                                       ByVal byte4 As Byte) As UInteger
        Try
            Dim bb(3) As Byte

            If BitConverter.IsLittleEndian Then
                bb(0) = byte1
                bb(1) = byte2
                bb(2) = byte3
                bb(3) = byte4
            Else
                bb(0) = byte4
                bb(1) = byte3
                bb(2) = byte2
                bb(3) = byte1
            End If

            Return BitConverter.ToUInt32(bb, 0)
        Catch ex As Exception
            Return 0
        End Try
    End Function
    Private Function RVFloatToSingle(ByVal byte1 As Byte, _
                                     ByVal byte2 As Byte, _
                                     ByVal byte3 As Byte, _
                                     ByVal byte4 As Byte) As Single
        Dim bb(3) As Byte

        If BitConverter.IsLittleEndian Then
            bb(0) = byte1
            bb(1) = byte2
            bb(2) = byte3
            bb(3) = byte4
        Else
            bb(0) = byte4
            bb(1) = byte3
            bb(2) = byte2
            bb(3) = byte1
        End If

        Try
            Return BitConverter.ToSingle(bb, 0)
        Catch ex As Exception
            Return 0.0
        End Try
    End Function
    Private Function RVColorToString(ByVal byte1 As Byte, _
                                     ByVal byte2 As Byte, _
                                     ByVal byte3 As Byte, _
                                     ByVal byte4 As Byte) As String
        If BitConverter.IsLittleEndian Then
            'BGRA to ARGB
            Return "0x" & Hex(byte4).PadLeft(2, "0") & Hex(byte3).PadLeft(2, "0") & Hex(byte2).PadLeft(2, "0") & Hex(byte1).PadLeft(2, "0")
        Else
            Return "0x" & Hex(byte1).PadLeft(2, "0") & Hex(byte2).PadLeft(2, "0") & Hex(byte3).PadLeft(2, "0") & Hex(byte4).PadLeft(2, "0")
        End If
    End Function

    Private Function LoadCoordUV(ByVal type As String, _
                                 ByVal coordu As String, _
                                 ByVal coordv As String) As Single(,)
        Dim coord_uv(,) As Single

        If type.StartsWith("Q") Then 'square
            ReDim coord_uv(1, 3)

            coord_uv(0, 0) = CSng(coordu.Split(multi_line)(0))
            coord_uv(0, 1) = CSng(coordu.Split(multi_line)(1))
            coord_uv(0, 2) = CSng(coordu.Split(multi_line)(2))
            coord_uv(0, 3) = CSng(coordu.Split(multi_line)(3))
            coord_uv(1, 0) = CSng(coordv.Split(multi_line)(0))
            coord_uv(1, 1) = CSng(coordv.Split(multi_line)(1))
            coord_uv(1, 2) = CSng(coordv.Split(multi_line)(2))
            coord_uv(1, 3) = CSng(coordv.Split(multi_line)(3))
        Else 'triangle
            ReDim coord_uv(1, 2)

            coord_uv(0, 0) = CSng(coordu.Split(multi_line)(0))
            coord_uv(0, 1) = CSng(coordu.Split(multi_line)(1))
            coord_uv(0, 2) = CSng(coordu.Split(multi_line)(2))
            coord_uv(1, 0) = CSng(coordv.Split(multi_line)(0))
            coord_uv(1, 1) = CSng(coordv.Split(multi_line)(1))
            coord_uv(1, 2) = CSng(coordv.Split(multi_line)(2))
        End If

        Return coord_uv
    End Function

    Public Function GetCmbTextureFileID(ByVal _cmb_text_ As String) As Integer
        Select Case _cmb_text_
            Case "file: a"
                Return 0
            Case "file: b"
                Return 1
            Case "file: c"
                Return 2
            Case "file: d"
                Return 3
            Case "file: e"
                Return 4
            Case "file: f"
                Return 5
            Case "file: g"
                Return 6
            Case "file: h"
                Return 7
            Case "file: i"
                Return 8
            Case "file: j"
                Return 9
            Case Else
                Return -1
        End Select
    End Function

    Private Sub RefreshNewUVCoords()
        Dim _new_scale_ As Single = 1.0

        If Not Me.pnlpic_texture_instance.BackgroundImage Is Nothing _
            AndAlso Not Me.pnlpic_texture_new.BackgroundImage Is Nothing Then

            If Me.pnlpic_texture_new.Width <> Me.pnlpic_texture_instance.Width Then
                _new_scale_ = CSng(Math.Round(CSng(Me.pnlpic_texture_new.Width) / CSng(Me.pnlpic_texture_instance.Width), 3))
            End If
        End If

        Dim coord_uv(,) As Single

        For i As Integer = 0 To poly_count - 1
            If polygon(1, i) = Me.cmb_instance_texture_list.Text Then
                If _new_scale_ = 1.0 Then
                    polygon(7, i) = String.Empty
                    polygon(8, i) = String.Empty
                Else
                    coord_uv = LoadCoordUV(polygon(0, i), polygon(4, i), polygon(5, i))

                    If polygon(0, i).StartsWith("Q") Then 'square
                        polygon(7, i) = (coord_uv(0, 0) / _new_scale_).ToString & multi_line & (coord_uv(0, 1) / _new_scale_).ToString & multi_line & (coord_uv(0, 2) / _new_scale_).ToString & multi_line & (coord_uv(0, 3) / _new_scale_).ToString
                        polygon(8, i) = (coord_uv(1, 0) / _new_scale_).ToString & multi_line & (coord_uv(1, 1) / _new_scale_).ToString & multi_line & (coord_uv(1, 2) / _new_scale_).ToString & multi_line & (coord_uv(1, 3) / _new_scale_).ToString
                    Else 'triangle
                        polygon(7, i) = (coord_uv(0, 0) / _new_scale_).ToString & multi_line & (coord_uv(0, 1) / _new_scale_).ToString & multi_line & (coord_uv(0, 2) / _new_scale_).ToString & multi_line & "0"
                        polygon(8, i) = (coord_uv(1, 0) / _new_scale_).ToString & multi_line & (coord_uv(1, 1) / _new_scale_).ToString & multi_line & (coord_uv(1, 2) / _new_scale_).ToString & multi_line & "0"
                    End If
                End If
            End If

            My.Application.DoEvents()
        Next
    End Sub

    '--- pic move management ---

    Dim picinst_down As Boolean = False
    Dim picinst_mouse_x As Integer = 0
    Dim picinst_mouse_y As Integer = 0
    Dim picinst_x As Integer
    Dim picinst_y As Integer

    Private Sub pnlpic_texture_instance_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlpic_texture_instance.MouseDown
        If Me.pnlpic_texture_instance.BackgroundImage IsNot Nothing Then
            picinst_x = Me.pnlpic_texture_instance.Location.X
            picinst_y = Me.pnlpic_texture_instance.Location.Y
            picinst_mouse_x = MousePosition.X
            picinst_mouse_y = MousePosition.Y
            picinst_down = True
            Me.pnlpic_texture_instance.Cursor = Cursors.SizeAll
        End If
    End Sub
    Private Sub pnlpic_texture_instance_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlpic_texture_instance.MouseMove
        If picinst_down Then
            If Me.pnlpic_texture_instance.Width > (Me.pnl_texture_instance.Width - 5) Then
                Dim new_x As Integer = picinst_x + (MousePosition.X - picinst_mouse_x)

                If new_x > 3 Then
                    new_x = 3
                End If
                If new_x < -(Me.pnlpic_texture_instance.Width - Me.pnl_texture_instance.Width + 5) Then
                    new_x = -(Me.pnlpic_texture_instance.Width - Me.pnl_texture_instance.Width + 5)
                End If

                Me.pnlpic_texture_instance.Left = new_x
            End If

            If Me.pnlpic_texture_instance.Height > (Me.pnl_texture_instance.Height - 5) Then
                Dim new_y As Integer = picinst_y + (MousePosition.Y - picinst_mouse_y)

                If new_y > 3 Then
                    new_y = 3
                End If
                If new_y < -(Me.pnlpic_texture_instance.Height - Me.pnl_texture_instance.Height + 5) Then
                    new_y = -(Me.pnlpic_texture_instance.Height - Me.pnl_texture_instance.Height + 5)
                End If

                Me.pnlpic_texture_instance.Top = new_y
            End If
        End If
    End Sub
    Private Sub pnlpic_texture_instance_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlpic_texture_instance.MouseUp
        picinst_down = False
        Me.pnlpic_texture_instance.Cursor = Cursors.Default

        Me.pnlpic_texture_instance.Refresh()
    End Sub

    Dim picnew_down As Boolean = False
    Dim picnew_mouse_x As Integer = 0
    Dim picnew_mouse_y As Integer = 0
    Dim picnew_x As Integer
    Dim picnew_y As Integer

    Private Sub pnlpic_texture_new_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlpic_texture_new.MouseDown
        If Me.pnlpic_texture_new.BackgroundImage IsNot Nothing Then
            picnew_x = Me.pnlpic_texture_new.Location.X
            picnew_y = Me.pnlpic_texture_new.Location.Y
            picnew_mouse_x = MousePosition.X
            picnew_mouse_y = MousePosition.Y
            picnew_down = True
            Me.pnlpic_texture_new.Cursor = Cursors.SizeAll
        End If
    End Sub
    Private Sub pnlpic_texture_new_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlpic_texture_new.MouseMove
        If picnew_down Then
            If Me.pnlpic_texture_new.Width > (Me.pnl_texture_new.Width - 5) Then
                Dim new_x As Integer = picnew_x + (MousePosition.X - picnew_mouse_x)

                If new_x > 3 Then
                    new_x = 3
                End If
                If new_x < -(Me.pnlpic_texture_new.Width - Me.pnl_texture_new.Width + 5) Then
                    new_x = -(Me.pnlpic_texture_new.Width - Me.pnl_texture_new.Width + 5)
                End If

                Me.pnlpic_texture_new.Left = new_x
            End If

            If Me.pnlpic_texture_new.Height > (Me.pnl_texture_new.Height - 5) Then
                Dim new_y As Integer = picnew_y + (MousePosition.Y - picnew_mouse_y)

                If new_y > 3 Then
                    new_y = 3
                End If
                If new_y < -(Me.pnlpic_texture_new.Height - Me.pnl_texture_new.Height + 5) Then
                    new_y = -(Me.pnlpic_texture_new.Height - Me.pnl_texture_new.Height + 5)
                End If

                Me.pnlpic_texture_new.Top = new_y
            End If
        End If
    End Sub
    Private Sub pnlpic_texture_new_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlpic_texture_new.MouseUp
        picnew_down = False
        Me.pnlpic_texture_new.Cursor = Cursors.Default

        Me.pnlpic_texture_new.Refresh()
    End Sub

    '--- image resize ---

    Private Function ResizeImage(ByVal bmSource As Drawing.Bitmap) As Drawing.Bitmap
        If zoom = 100.0 Then
            Return bmSource
        Else
            Dim bmDest As New Drawing.Bitmap(CInt(CDbl(bmSource.Width) * zoom / 100.0), CInt(CDbl(bmSource.Height) * zoom / 100.0), Drawing.Imaging.PixelFormat.Format32bppArgb)

            Using grDest = Drawing.Graphics.FromImage(bmDest)
                With grDest
                    .CompositingQuality = Drawing.Drawing2D.CompositingQuality.HighQuality
                    .InterpolationMode = Drawing.Drawing2D.InterpolationMode.NearestNeighbor
                    .PixelOffsetMode = Drawing.Drawing2D.PixelOffsetMode.HighQuality
                    .SmoothingMode = Drawing.Drawing2D.SmoothingMode.AntiAlias
                    .CompositingMode = Drawing.Drawing2D.CompositingMode.SourceOver

                    .DrawImage(bmSource, 0, 0, bmDest.Width, bmDest.Height)
                End With
            End Using

            Return bmDest
        End If
    End Function

End Class
